import { Runner } from './plugins/runner';
import { createStoreHook } from './core/create-store-hook';

var ConfigCreateStore = /*#__PURE__*/function () {
  function ConfigCreateStore() {
    this.storeNameList = [];
  }

  var _proto = ConfigCreateStore.prototype;

  _proto.readStoreNameCheck = function readStoreNameCheck(name) {
    if (this.storeNameList.includes(name)) {
      console.error(name + " \u5DF2\u7ECF\u88AB\u5176\u4ED6 store \u4F7F\u7528\u4E86, \u8BF7\u91CD\u65B0\u914D\u7F6E");
    }

    if (name === undefined) {
      throw new Error('配置 store 必须配置 name 字段');
    } else {
      this.storeNameList.push(name);
    }
  };

  _proto.main = function main(config) {
    var _this = this;

    var runner = new Runner();
    config.plugins.forEach(function (plugin) {
      plugin.apply(runner);
    });
    return function (storeConfig) {
      _this.readStoreNameCheck(storeConfig.name);

      return createStoreHook.main(storeConfig);
    };
  };

  return ConfigCreateStore;
}();

export var configCreateStore = new ConfigCreateStore();