import _extends from "@babel/runtime/helpers/esm/extends";
import pick from 'object.pick';
import omit from 'object.omit';
export function membraneIs(_ref) {
  var membraneObject = _ref.membraneObject,
      bindPropsKeys = _ref.bindPropsKeys,
      extraContext = _ref.extraContext,
      omitKeys = _ref.omitKeys;
  var protectedObject = omit(membraneObject, 'membrane');

  var membrane = _extends({}, membraneObject.membrane);

  var superContext = _extends({}, omit(protectedObject, omitKeys), extraContext);

  bindPropsKeys.forEach(function (key) {
    for (var methodKey in membrane[key]) {
      if (Object.hasOwnProperty.call(membrane[key], methodKey)) {
        var method = membrane[key][methodKey];
        membrane[key][methodKey] = method.bind(superContext);
      }
    }
  });
  var protectedObjectKeys = Object.Keys(protectedObject);

  var membraneInObject = _extends({}, protectedObject, membraneObject);

  var exportObject = pick(membraneInObject, protectedObjectKeys);
  return exportObject;
}