import { SyncHook, AsyncParallelHook } from 'tapable';
export var Runner = /*#__PURE__*/function () {
  function Runner() {
    this.hooks = {
      run: new SyncHook(['methodName', 'methodParams']),
      runAsync: new AsyncParallelHook(['methodName', 'methodParams'])
    };
  }

  var _proto = Runner.prototype;

  _proto.beforeRun = function beforeRun(methodName, methodParams) {
    this.hooks.run.call(methodName, methodParams);
  };

  _proto.beforeRunAsync = function beforeRunAsync(methodName, methodParams, callback) {
    this.hooks.runAsync.callAsync(methodName, methodParams, function (err) {
      if (err) return callback(err);
      callback(methodName, methodParams);
    });
  };

  return Runner;
}();