"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createReducerCase = exports.reducerUtils = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _shared = require("./shared");

var CreateReducerCase = /*#__PURE__*/function () {
  function CreateReducerCase() {}

  var _proto = CreateReducerCase.prototype;

  _proto.readIsFunction = function readIsFunction(value) {
    return typeof value === 'function';
  };

  _proto.readIsStateIsUndefined = function readIsStateIsUndefined(nextState, stateKeys) {
    var nextStateKeys = Object.keys(nextState);
    var ghostKeys = nextStateKeys.filter(function (key) {
      return !stateKeys.includes(key);
    });

    if (ghostKeys.length) {
      throw new Error("\u4E0D\u5B58\u5728\u7684 state => [" + ghostKeys.toString() + "], \u8BF7\u786E\u4FDDsetState\u4E2D\u66F4\u65B0\u7684state\u5728initState\u4E2D\u5DF2\u7ECF\u58F0\u660E");
    }
  };

  _proto.main = function main(stateKeys, dispatch, state) {
    var _this = this;

    var rc = {
      setState: function setState(nextState) {
        console.log(nextState, 19);

        if (_this.readIsFunction(nextState)) {
          console.log(nextState, 21);
          dispatch(['setState', nextState(state)]);
        }

        _this.readIsStateIsUndefined(nextState, stateKeys);

        dispatch(['setState', nextState]);
      }
    };
    stateKeys.forEach(function (stateKey) {
      var type = _shared.shared.getReducerType.main(stateKey);

      rc[type] = function (payload) {
        if (_this.readIsFunction(payload)) {
          dispatch([type, payload(state[stateKey])]);
        } else {
          dispatch([type, payload]);
        }
      };
    });
    return rc;
  };

  return CreateReducerCase;
}();

var ReducerUtils = /*#__PURE__*/function () {
  function ReducerUtils() {}

  var _proto2 = ReducerUtils.prototype;

  _proto2.readActionIsUndefined = function readActionIsUndefined(reducerModel, action) {
    if (reducerModel[action[0]] === undefined) {
      throw new Error("\u4E0D\u5B58\u5728\u7684 action => " + action[0] + ", \u6E05\u6838\u5BF9\u4EE3\u7801");
    }
  };

  _proto2.writeGetReducerModel = function writeGetReducerModel(stateKeys) {
    // eslint-disable-next-line no-unused-vars
    return function (state) {
      var reducerModel = {
        setState: function setState(nextState) {
          return (0, _extends2.default)({}, nextState);
        }
      };
      stateKeys.forEach(function (stateKey) {
        var type = _shared.shared.getReducerType.main(stateKey);

        reducerModel[type] = function (payload) {
          var _ref2;

          if (Array.isArray(payload)) {
            var _ref;

            return _ref = {}, _ref[stateKey] = payload.map(function (p) {
              return p;
            }), _ref;
          }

          return _ref2 = {}, _ref2[stateKey] = payload, _ref2;
        };
      });
      return reducerModel;
    };
  };

  _proto2.main = function main(stateKeys) {
    var _this2 = this;

    return function (state, action) {
      var reducerModel = _this2.writeGetReducerModel(stateKeys)(state);

      _this2.readActionIsUndefined(reducerModel, action);

      var result = reducerModel[action[0]](action[1]);
      console.group(action[0]);
      console.log('prev store.state =>', state);
      console.log('next state =>', action[1]);
      console.groupEnd();
      return (0, _extends2.default)({}, state, result);
    };
  };

  return ReducerUtils;
}();

var reducerUtils = new ReducerUtils();
exports.reducerUtils = reducerUtils;
var createReducerCase = new CreateReducerCase();
exports.createReducerCase = createReducerCase;