"use strict";

exports.__esModule = true;
exports.configCreateStore = configCreateStore;
exports.createStoreContext = createStoreContext;
exports.default = exports.AppContext = void 0;

var _configCreateStore = require("./config-create-store");

var _createStoreHook = require("./core/create-store-hook");

var _appContext = require("./core/app-context");

exports.AppContext = _appContext.AppContext;

function configCreateStore(config) {
  return _configCreateStore.configCreateStore.main(config);
} // 兼容 1.x 版本下的 createStore API


function createStore(storeConfig) {
  return _createStoreHook.createStoreHook.main(storeConfig);
}

function createStoreContext(storeConfig) {
  storeConfig.name = 'storeContext';
  return _createStoreHook.createStoreHook.main(storeConfig);
}

var _default = createStore;
exports.default = _default;