"use strict";

exports.__esModule = true;
exports.ConsoleLoggerPlugin = void 0;

var ConsoleLoggerPlugin = /*#__PURE__*/function () {
  function ConsoleLoggerPlugin(debug) {
    this.debug = debug;
  }

  var _proto = ConsoleLoggerPlugin.prototype;

  _proto.logGroup = function logGroup(key, info, storeName, args) {
    console.group(storeName + "." + key);
    var arg = args.length > 0 ? args : ['没有入参'];

    if (info) {
      var _console;

      (_console = console).debug.apply(_console, ["\u8BF4\u660E: " + info + " \u5165\u53C2:"].concat(arg));
    } else {
      var _console2;

      (_console2 = console).debug.apply(_console2, ['入参:'].concat(arg));
    }

    console.groupEnd();
  };

  _proto.apply = function apply(runner) {
    var _this = this;

    if (!this.debug) {
      return;
    }

    runner.hook.beforeRun.tap('ConsoleLoggerPlugin', function (key, info, storeName, args) {
      _this.logGroup(key, info, storeName, args);
    });
  };

  return ConsoleLoggerPlugin;
}();

exports.ConsoleLoggerPlugin = ConsoleLoggerPlugin;